﻿namespace Section3_2.ViewModels
{
    using YKToolkit.Bindings;

    public class MainViewModel : NotificationObject
    {
        private string text;
        /// <summary>
        /// 文字列を取得または設定します。
        /// </summary>
        public string Text
        {
            get { return text; }
            set
            {
                if (SetProperty(ref text, value))
                {
                    Result = text.ToUpper();
                }
            }
        }

        private string result;
        /// <summary>
        /// 処理結果を取得または設定します。
        /// </summary>
        public string Result
        {
            get { return result; }
            set { SetProperty(ref result, value); }
        }

        private DelegateCommand clearCommand;
        /// <summary>
        /// 文字列をクリアするコマンドを取得します。
        /// </summary>
        public DelegateCommand ClearCommand
        {
            get
            {
                if (clearCommand == null)
                    clearCommand = new DelegateCommand(
                    _ => Text = string.Empty,
                    _ => !string.IsNullOrEmpty(Text)
                    );
                return clearCommand;
            }
        }
    }
}
